<?php

require_once 'bij1algemeen.civix.php';
// phpcs:disable
use CRM_Bij1algemeen_ExtensionUtil as E;
// phpcs:enable
use \Symfony\Component\DependencyInjection\ContainerBuilder;
use \Symfony\Component\DependencyInjection\Definition;
// phpcs:enable

/**
 * Implements hook_civicrm_container()
 *
 * @link https://docs.civicrm.org/dev/en/latest/hooks/hook_civicrm_container/
 */
function bij1algemeen_civicrm_container(ContainerBuilder $container) {
  $container->addCompilerPass(new Civi\Bij1algemeen\Bij1AlgemeenContainer());
}

/**
 * Implements hook_civicrm_navigationMenu().
 *
 * @link https://docs.civicrm.org/dev/en/latest/hooks/hook_civicrm_navigationMenu()/
 */
function bij1algemeen_civicrm_navigationMenu(&$menu) {
  _bij1algemeen_civix_insert_navigation_menu($menu, 'Administer', array(
    'label' => E::ts('BIJ1 Specifieke Instellingen'),
    'name' => 'bij1_instellingen',
    'url' => CRM_Utils_System::url('civicrm/bij1algemeen/form/instellingen', 'reset=1&action=update', TRUE),
    'permission' => 'administer CiviCRM',
    'operator' => 'OR',
    'separator' => 0,
  ));
  _bij1algemeen_civix_navigationMenu($menu);
}

/**
 * Implements hook_civicrm_config().
 *
 * @link https://docs.civicrm.org/dev/en/latest/hooks/hook_civicrm_config/
 */
function bij1algemeen_civicrm_config(&$config) {
  _bij1algemeen_civix_civicrm_config($config);
}

/**
 * Implements hook_civicrm_xmlMenu().
 *
 * @link https://docs.civicrm.org/dev/en/latest/hooks/hook_civicrm_xmlMenu
 */
function bij1algemeen_civicrm_xmlMenu(&$files) {
  _bij1algemeen_civix_civicrm_xmlMenu($files);
}

/**
 * Implements hook_civicrm_install().
 *
 * @link https://docs.civicrm.org/dev/en/latest/hooks/hook_civicrm_install
 */
function bij1algemeen_civicrm_install() {
  _bij1algemeen_civix_civicrm_install();
}

/**
 * Implements hook_civicrm_postInstall().
 *
 * @link https://docs.civicrm.org/dev/en/latest/hooks/hook_civicrm_postInstall
 */
function bij1algemeen_civicrm_postInstall() {
  _bij1algemeen_civix_civicrm_postInstall();
}

/**
 * Implements hook_civicrm_uninstall().
 *
 * @link https://docs.civicrm.org/dev/en/latest/hooks/hook_civicrm_uninstall
 */
function bij1algemeen_civicrm_uninstall() {
  _bij1algemeen_civix_civicrm_uninstall();
}

/**
 * Implements hook_civicrm_enable().
 *
 * @link https://docs.civicrm.org/dev/en/latest/hooks/hook_civicrm_enable
 */
function bij1algemeen_civicrm_enable() {
  _bij1algemeen_civix_civicrm_enable();
}

/**
 * Implements hook_civicrm_disable().
 *
 * @link https://docs.civicrm.org/dev/en/latest/hooks/hook_civicrm_disable
 */
function bij1algemeen_civicrm_disable() {
  _bij1algemeen_civix_civicrm_disable();
}

/**
 * Implements hook_civicrm_upgrade().
 *
 * @link https://docs.civicrm.org/dev/en/latest/hooks/hook_civicrm_upgrade
 */
function bij1algemeen_civicrm_upgrade($op, CRM_Queue_Queue $queue = NULL) {
  return _bij1algemeen_civix_civicrm_upgrade($op, $queue);
}

/**
 * Implements hook_civicrm_managed().
 *
 * Generate a list of entities to create/deactivate/delete when this module
 * is installed, disabled, uninstalled.
 *
 * @link https://docs.civicrm.org/dev/en/latest/hooks/hook_civicrm_managed
 */
function bij1algemeen_civicrm_managed(&$entities) {
  _bij1algemeen_civix_civicrm_managed($entities);
}

/**
 * Implements hook_civicrm_caseTypes().
 *
 * Generate a list of case-types.
 *
 * Note: This hook only runs in CiviCRM 4.4+.
 *
 * @link https://docs.civicrm.org/dev/en/latest/hooks/hook_civicrm_caseTypes
 */
function bij1algemeen_civicrm_caseTypes(&$caseTypes) {
  _bij1algemeen_civix_civicrm_caseTypes($caseTypes);
}

/**
 * Implements hook_civicrm_angularModules().
 *
 * Generate a list of Angular modules.
 *
 * Note: This hook only runs in CiviCRM 4.5+. It may
 * use features only available in v4.6+.
 *
 * @link https://docs.civicrm.org/dev/en/latest/hooks/hook_civicrm_angularModules
 */
function bij1algemeen_civicrm_angularModules(&$angularModules) {
  _bij1algemeen_civix_civicrm_angularModules($angularModules);
}

/**
 * Implements hook_civicrm_alterSettingsFolders().
 *
 * @link https://docs.civicrm.org/dev/en/latest/hooks/hook_civicrm_alterSettingsFolders
 */
function bij1algemeen_civicrm_alterSettingsFolders(&$metaDataFolders = NULL) {
  _bij1algemeen_civix_civicrm_alterSettingsFolders($metaDataFolders);
}

/**
 * Implements hook_civicrm_entityTypes().
 *
 * Declare entity types provided by this module.
 *
 * @link https://docs.civicrm.org/dev/en/latest/hooks/hook_civicrm_entityTypes
 */
function bij1algemeen_civicrm_entityTypes(&$entityTypes) {
  _bij1algemeen_civix_civicrm_entityTypes($entityTypes);
}

/**
 * Implements hook_civicrm_themes().
 */
function bij1algemeen_civicrm_themes(&$themes) {
  _bij1algemeen_civix_civicrm_themes($themes);
}

// --- Functions below this ship commented out. Uncomment as required. ---

/**
 * Implements hook_civicrm_preProcess().
 *
 * @link https://docs.civicrm.org/dev/en/latest/hooks/hook_civicrm_preProcess
 */
//function bij1algemeen_civicrm_preProcess($formName, &$form) {
//
//}

/**
 * Implements hook_civicrm_navigationMenu().
 *
 * @link https://docs.civicrm.org/dev/en/latest/hooks/hook_civicrm_navigationMenu
 */
//function bij1algemeen_civicrm_navigationMenu(&$menu) {
//  _bij1algemeen_civix_insert_navigation_menu($menu, 'Mailings', array(
//    'label' => E::ts('New subliminal message'),
//    'name' => 'mailing_subliminal_message',
//    'url' => 'civicrm/mailing/subliminal',
//    'permission' => 'access CiviMail',
//    'operator' => 'OR',
//    'separator' => 0,
//  ));
//  _bij1algemeen_civix_navigationMenu($menu);
//}
